/*
 * vim: ts=4 nobackup
 */


#include <stdint.h>
#include <stdlib.h>
#include <avr/io.h>
#include "util.H"
#include "Timer.H"
#include "USB.H"
#include "MyLcd20x4Screen.H"


using namespace std;
using namespace avelino;


MyLcd20x4Screen lcd;
char aux[3];


int main() {
	//USB::powerOff();
	USB::init();
	Timer::init();
	lcd.init();
	lcd.print(0, 0, "USB test:");
	bool deviceDescriptorSent = true;
	bool configurationDescriptorSent = true;
	uint8_t address = 0xFF;
	/*
	lcd.print(1, 1,  "dev desc sent: ");
	lcd.print(0, 2, "conf desc sent: ");
	lcd.print(0, 3, "device address: ");
	lcd.print(18, 3, "h");
	*/
	lcd.print(0, 1, "device address: ");
	lcd.print(18, 1, "h");
	bool rxBufferFull = false;
	while (true) {
		/*
		if (deviceDescriptorSent != USB::deviceDescriptorSent) {
			lcd.print(16, 1, (USB::deviceDescriptorSent) ? "y" : "n");
			deviceDescriptorSent = USB::deviceDescriptorSent;
		}
		if (configurationDescriptorSent != USB::configurationDescriptorSent) {
			lcd.print(16, 2, (USB::configurationDescriptorSent) ? "y" : "n");
			configurationDescriptorSent = USB::configurationDescriptorSent;
		}
		if (address != USB::address) {
			lcd.printHex(16, 3, USB::address);
			address = USB::address;
		}
		*/
		if (address != USB::address) {
			lcd.printHex(16, 1, USB::address);
			address = USB::address;
		}
		if (rxBufferFull != USB::rxBufferFull) {
			lcd.print(0, 2, (char *) USB::rxBuffer);
			rxBufferFull = USB::rxBufferFull;
		}
		lcd.run();
	}
	return 0;
}
