

#ifndef  __MY_LCD20X4_SCREEN_H__
#define  __MY_LCD20X4_SCREEN_H__


#include <stdint.h>
#include "Lcd20x4Screen.H"


extern "C++" {
	namespace avelino {
		using namespace std;

		class MyLcd20x4Screen : public Lcd20x4Screen {
			protected:
				uint8_t characterBitmapEntryTableSize;
				CharacterBitmapEntry *characterBitmapEntryTable;
				void configurePorts();
				void setNibble(uint8_t v);
				void setRS(bool v);
				void setE(bool v);
				CharacterBitmapEntry *getCharacterBitmapEntryTable(uint8_t &size);
			public:
				MyLcd20x4Screen();
		};
	}
}

#endif  // __MY_LCD20X4_H__
